Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void AckleyEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(AckleyEvaluator));
+      AckleyEvaluator target = new AckleyEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void BealeEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(BealeEvaluator));
+      BealeEvaluator target = new BealeEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void BoothEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(BoothEvaluator));
+      BoothEvaluator target = new BoothEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void GriewankEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(GriewankEvaluator));
+      GriewankEvaluator target = new GriewankEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void LevyEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(LevyEvaluator));
+      LevyEvaluator target = new LevyEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void MatyasEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(MatyasEvaluator));
+      MatyasEvaluator target = new MatyasEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void RastriginEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(RastriginEvaluator));
+      RastriginEvaluator target = new RastriginEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void RosenbrockEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(RosenbrockEvaluator));
+      RosenbrockEvaluator target = new RosenbrockEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void SphereEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(SphereEvaluator));
+      SphereEvaluator target = new SphereEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void SumSquaresEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(SumSquaresEvaluator));
+      SumSquaresEvaluator target = new SumSquaresEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs	(revision 14353)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs	(revision 14354)
@@ -37,13 +37,11 @@
     [TestProperty("Time", "short")]
     public void ZakharovEvaluateFunctionTest() {
-      var privateObject = new PrivateObject(typeof(ZakharovEvaluator));
+      ZakharovEvaluator target = new ZakharovEvaluator();
       RealVector point = null;
-      double expected = (double)privateObject.GetProperty("BestKnownQuality");
+      double expected = target.BestKnownQuality;
       double actual;
-      int minimumProblemSize = (int)privateObject.GetProperty("MinimumProblemSize");
-      int maximumProblemSize = (int)privateObject.GetProperty("MaximumProblemSize");
-      for (int dimension = minimumProblemSize; dimension <= System.Math.Min(10, maximumProblemSize); dimension++) {
-        point = (RealVector)privateObject.Invoke("GetBestKnownSolution", dimension);
-        actual = (double)privateObject.Invoke("Evaluate", point);
+      for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
+        point = target.GetBestKnownSolution(dimension);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }