Index: /branches/Templates/EmptyPlugin/EmptyPlugin.sln
===================================================================
--- /branches/Templates/EmptyPlugin/EmptyPlugin.sln	(revision 14360)
+++ /branches/Templates/EmptyPlugin/EmptyPlugin.sln	(revision 14360)
@@ -0,0 +1,22 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 14
+VisualStudioVersion = 14.0.25123.0
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "EmptyPlugin", "EmptyPlugin\EmptyPlugin.csproj", "{CCD920DC-6058-440B-A0A3-1527984AABD3}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Release|Any CPU = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{CCD920DC-6058-440B-A0A3-1527984AABD3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{CCD920DC-6058-440B-A0A3-1527984AABD3}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{CCD920DC-6058-440B-A0A3-1527984AABD3}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{CCD920DC-6058-440B-A0A3-1527984AABD3}.Release|Any CPU.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /branches/Templates/EmptyPlugin/EmptyPlugin/EmptyPlugin.csproj
===================================================================
--- /branches/Templates/EmptyPlugin/EmptyPlugin/EmptyPlugin.csproj	(revision 14360)
+++ /branches/Templates/EmptyPlugin/EmptyPlugin/EmptyPlugin.csproj	(revision 14360)
@@ -0,0 +1,57 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{CCD920DC-6058-440B-A0A3-1527984AABD3}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>EmptyPlugin</RootNamespace>
+    <AssemblyName>EmptyPlugin</AssemblyName>
+    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/Templates/EmptyPlugin/EmptyPlugin/Plugin.cs
===================================================================
--- /branches/Templates/EmptyPlugin/EmptyPlugin/Plugin.cs	(revision 14360)
+++ /branches/Templates/EmptyPlugin/EmptyPlugin/Plugin.cs	(revision 14360)
@@ -0,0 +1,40 @@
+﻿using HeuristicLab.PluginInfrastructure;
+
+namespace EmptyPlugin {
+  [Plugin("EmptyPlugin", "1.0")]
+  [PluginFile("EmptyPlugin.dll", PluginFileType.Assembly)] // each plugin represents a collection of files. The minimum is one file; the assembly.
+
+  // Usually your plugin references other HeuristicLab dlls. If you are referencing files (e.g. assemblies)
+  // from another plugin the corresponding plugin should be added as a dependency.
+  // Usually, if this information is incorrect you will still be able to use you plugin, but HL functionality
+  // which uses plugin dependency resolution will not work correctly. For instance if plugin dependencies are
+  // not correct then your plugin cannot be used on HeuristicLab.Hive
+  // 
+  // [PluginDependency("HeuristicLab.Data", "3.3")]
+  // [PluginDependency("HeuristicLab.Core", "3.3")]
+
+  // HL plugin infrastructure discovers plugins on startup by trying to load all .dll and .exe files and looking for 
+  // classes deriving from PluginBase. The meta-information for the plugin class is specified in the attributes
+  // above, and used by plugin infrastructure primarily for plugin dependency resolution.
+
+  // Steps:
+  // (1) Check out HL source code (e.g. the trunk version)
+  // (2) Build external libraries HeuristicLab.ExtLibs.sln using the Build.cmd (in the path of the HL source code)
+  // (3) Build HeuristicLab 3.3.sln using the Build.cmd
+  // (4) Build this project. The output path for binaries is set to "".
+  //     this assumes you have the following folder structure
+  //    <ROOT>
+  //    |..hl
+  //       |..branches
+  //       |  |..Templates
+  //       |     |..EmptyPlugin
+  //       |..trunk
+  //          |..sources
+  //             |.. bin 
+
+  //  (5) Check that the output file has been added to the HL binaries folder (hl/trunk/sources/bin/EmptyPlugin.dll)
+  //  (6) Start hl/trunk/sources/bin/HeuristicLab.exe and open the "Plugin Manager".
+  //      Make sure your EmptyPlugin appears in the list of loaded plugins 
+  public class Plugin : PluginBase {
+  }
+}
Index: /branches/Templates/EmptyPlugin/EmptyPlugin/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Templates/EmptyPlugin/EmptyPlugin/Properties/AssemblyInfo.cs	(revision 14360)
+++ /branches/Templates/EmptyPlugin/EmptyPlugin/Properties/AssemblyInfo.cs	(revision 14360)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("EmptyPlugin")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HP Inc.")]
+[assembly: AssemblyProduct("EmptyPlugin")]
+[assembly: AssemblyCopyright("Copyright © HP Inc. 2016")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("ccd920dc-6058-440b-a0a3-1527984aabd3")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]