Index: /branches/Templates/EmptyAlgorithm/EmptyAlgorithm.sln
===================================================================
--- /branches/Templates/EmptyAlgorithm/EmptyAlgorithm.sln	(revision 14362)
+++ /branches/Templates/EmptyAlgorithm/EmptyAlgorithm.sln	(revision 14362)
@@ -0,0 +1,22 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 14
+VisualStudioVersion = 14.0.25123.0
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "EmptyAlgorithm", "EmptyAlgorithm\EmptyAlgorithm.csproj", "{557A23CE-9A5E-44F5-AEA2-4F4F33C1511F}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Release|Any CPU = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{557A23CE-9A5E-44F5-AEA2-4F4F33C1511F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{557A23CE-9A5E-44F5-AEA2-4F4F33C1511F}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{557A23CE-9A5E-44F5-AEA2-4F4F33C1511F}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{557A23CE-9A5E-44F5-AEA2-4F4F33C1511F}.Release|Any CPU.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/MyAlgorithm.cs
===================================================================
--- /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/MyAlgorithm.cs	(revision 14362)
+++ /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/MyAlgorithm.cs	(revision 14362)
@@ -0,0 +1,71 @@
+﻿using System.Threading;
+using HeuristicLab.Common; // required for parameters collection
+using HeuristicLab.Core; // required for parameters collection
+using HeuristicLab.Data; // IntValue, ...
+using HeuristicLab.Optimization; // BasicAlgorithm
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace EmptyAlgorithm {
+  // each HL item needs to have a name and a description (BasicAlgorithm is an Item)
+  // The name and description of items is shown in the GUI
+  [Item(Name = "MyAlgorithm", Description = "An demo algorithm.")]
+
+  // If the algorithm should be shown in the "New..." dialog it must be creatable. Entries in the new dialog are grouped to categories and ordered by priorities
+  [Creatable(Category = CreatableAttribute.Categories.Algorithms, Priority = 999)]
+
+  [StorableClass] // for persistence (storing your algorithm to a files or transfer to HeuristicLab.Hive
+  public class MyAlgorithm : BasicAlgorithm {
+    #region parameters
+    // If an algorithm has parameters then we usually also add properties to access these parameters.
+    // This is not strictly required but considered good shape.
+    private IFixedValueParameter<IntValue> MaxIterationsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["MaxIterations"]; }
+    }
+    public int MaxIterations {
+      get { return MaxIterationsParameter.Value.Value; }
+      set { MaxIterationsParameter.Value.Value = value; }
+    }
+    #endregion
+
+    // createable items must have a default ctor
+    public MyAlgorithm() {
+      // algorithm parameters are shown in the GUI
+      Parameters.Add(new FixedValueParameter<IntValue>("MaxIterations", new IntValue(10000)));
+    }
+
+    // Persistence uses this ctor to improve deserialization efficiency.
+    // If we would use the default ctor instead this would completely initialize the object (e.g. creating parameters)
+    // even though the data is later overwritten by the stored data.
+    [StorableConstructor]
+    public MyAlgorithm(bool deserializing) : base(deserializing) { }
+
+    // Each clonable item must have a cloning ctor (deep cloning, the cloner is used to handle cyclic object references)
+    public MyAlgorithm(MyAlgorithm original, Cloner cloner) : base(original, cloner) {
+      // Don't forget to call the cloning ctor of the base class
+      // This class does not have fields, therefore we don't need to actually clone anything
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MyAlgorithm(this, cloner);
+    }
+
+    protected override void Run(CancellationToken cancellationToken) {
+      int maxIters = MaxIterations;
+
+
+      var curIters = new IntValue();
+      var curItersResult = new Result("Iteration", curIters);
+      Results.Add(curItersResult);
+
+      for (int i = 0; i < maxIters; i++) {
+        curIters.Value = i;
+
+        // check the cancellation token to see if the used clicked "Stop"
+        if (cancellationToken.IsCancellationRequested) break;
+      }
+
+      Results.Add(new Result("Execution time", new TimeSpanValue(this.ExecutionTime)));
+    }
+  }
+}
Index: /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Plugin.cs
===================================================================
--- /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Plugin.cs	(revision 14362)
+++ /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Plugin.cs	(revision 14362)
@@ -0,0 +1,40 @@
+﻿using HeuristicLab.PluginInfrastructure;
+
+namespace EmptyAlgorithm {
+  [Plugin("EmptyAlgorithm", "1.0")]
+  [PluginFile("EmptyAlgorithm.dll", PluginFileType.Assembly)] // each plugin represents a collection of files. The minimum is one file; the assembly.
+
+  // Usually your plugin references other HeuristicLab dlls. If you are referencing files (e.g. assemblies)
+  // from another plugin the corresponding plugin should be added as a dependency.
+  // Usually, if this information is incorrect you will still be able to use you plugin, but HL functionality
+  // which uses plugin dependency resolution will not work correctly. For instance if plugin dependencies are
+  // not correct then your plugin cannot be used on HeuristicLab.Hive
+  // 
+  // [PluginDependency("HeuristicLab.Data", "3.3")]
+  // [PluginDependency("HeuristicLab.Core", "3.3")]
+
+  // HL plugin infrastructure discovers plugins on startup by trying to load all .dll and .exe files and looking for 
+  // classes deriving from PluginBase. The meta-information for the plugin class is specified in the attributes
+  // above, and used by plugin infrastructure primarily for plugin dependency resolution.
+
+  // Steps:
+  // (1) Check out HL source code (e.g. the trunk version)
+  // (2) Build external libraries HeuristicLab.ExtLibs.sln using the Build.cmd (in the path of the HL source code)
+  // (3) Build HeuristicLab 3.3.sln using the Build.cmd
+  // (4) Build this project. The output path for binaries is set to "".
+  //     this assumes you have the following folder structure
+  //    <ROOT>
+  //    |..hl
+  //       |..branches
+  //       |  |..Templates
+  //       |     |..EmptyPlugin
+  //       |..trunk
+  //          |..sources
+  //             |.. bin 
+
+  //  (5) Check that the output file has been added to the HL binaries folder (hl/trunk/sources/bin/EmptyPlugin.dll)
+  //  (6) Start hl/trunk/sources/bin/HeuristicLab.exe and open the "Plugin Manager".
+  //      Make sure your EmptyPlugin appears in the list of loaded plugins 
+  public class Plugin : PluginBase {
+  }
+}
Index: /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Properties/AssemblyInfo.cs	(revision 14362)
+++ /branches/Templates/EmptyAlgorithm/EmptyAlgorithm/Properties/AssemblyInfo.cs	(revision 14362)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("EmptyAlgorithm")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HP Inc.")]
+[assembly: AssemblyProduct("EmptyAlgorithm")]
+[assembly: AssemblyCopyright("Copyright © HP Inc. 2016")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("557a23ce-9a5e-44f5-aea2-4f4f33c1511f")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]