Index: /branches/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs
===================================================================
--- /branches/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs	(revision 14374)
+++ /branches/HeuristicLab.Algorithms.DataAnalysis.Glmnet/3.4/ElasticNetLinearRegression.cs	(revision 14375)
@@ -135,5 +135,5 @@
       RunElasticNetLinearRegression(Problem.ProblemData, Penality, out lambda, out trainNMSE, out testNMSE, out coeff, out intercept);
 
-      var coeffTable = new IndexedDataTable<double>("Coefficient Paths", "The paths of standarized coefficient values over different lambda values");
+      var coeffTable = new IndexedDataTable<double>("Coefficients", "The paths of standarized coefficient values over different lambda values");
       coeffTable.VisualProperties.YAxisMaximumAuto = false;
       coeffTable.VisualProperties.YAxisMinimumAuto = false;
@@ -143,5 +143,5 @@
       coeffTable.VisualProperties.XAxisLogScale = true;
       coeffTable.VisualProperties.XAxisTitle = "Log10(Lambda)";
-      coeffTable.VisualProperties.YAxisTitle = "Coefficient value";
+      coeffTable.VisualProperties.YAxisTitle = "Coefficients";
       coeffTable.VisualProperties.SecondYAxisTitle = "Number of variables";
 
@@ -175,30 +175,29 @@
       Results.Add(new Result(coeffTable.Name, coeffTable.Description, coeffTable));
 
-      var nmsePlot = new IndexedDataTable<double>("NMSE", "Path of NMSE values over different lambda values");
-      nmsePlot.VisualProperties.YAxisMaximumAuto = false;
-      nmsePlot.VisualProperties.YAxisMinimumAuto = false;
-      nmsePlot.VisualProperties.XAxisMaximumAuto = false;
-      nmsePlot.VisualProperties.XAxisMinimumAuto = false;
-
-      nmsePlot.VisualProperties.YAxisMinimumFixedValue = 0;
-      nmsePlot.VisualProperties.YAxisMaximumFixedValue = 1.0;
-      nmsePlot.VisualProperties.XAxisLogScale = true;
-      nmsePlot.VisualProperties.XAxisTitle = "Log10(Lambda)";
-      nmsePlot.VisualProperties.YAxisTitle = "Normalized mean of squared errors (NMSE)";
-      nmsePlot.VisualProperties.SecondYAxisTitle= "Number of variables";
-      nmsePlot.Rows.Add(new IndexedDataRow<double>("NMSE (train)", "Path of NMSE values over different lambda values", lambda.Zip(trainNMSE, (l, v) => Tuple.Create(l, v))));
-      nmsePlot.Rows.Add(new IndexedDataRow<double>("NMSE (test)", "Path of NMSE values over different lambda values", lambda.Zip(testNMSE, (l, v) => Tuple.Create(l, v))));
-      nmsePlot.Rows.Add(new IndexedDataRow<double>("Number of variables", "The number of non-zero coefficients for each step in the path", lambda.Zip(numNonZeroCoeffs, (l, v) => Tuple.Create(l, (double)v))));
+      var errorTable = new IndexedDataTable<double>("NMSE", "Path of NMSE values over different lambda values");
+      errorTable.VisualProperties.YAxisMaximumAuto = false;
+      errorTable.VisualProperties.YAxisMinimumAuto = false;
+      errorTable.VisualProperties.XAxisMaximumAuto = false;
+      errorTable.VisualProperties.XAxisMinimumAuto = false;
+
+      errorTable.VisualProperties.YAxisMinimumFixedValue = 0;
+      errorTable.VisualProperties.YAxisMaximumFixedValue = 1.0;
+      errorTable.VisualProperties.XAxisLogScale = true;
+      errorTable.VisualProperties.XAxisTitle = "Log10(Lambda)";
+      errorTable.VisualProperties.YAxisTitle = "Normalized mean of squared errors (NMSE)";
+      errorTable.VisualProperties.SecondYAxisTitle= "Number of variables";
+      errorTable.Rows.Add(new IndexedDataRow<double>("NMSE (train)", "Path of NMSE values over different lambda values", lambda.Zip(trainNMSE, (l, v) => Tuple.Create(l, v))));
+      errorTable.Rows.Add(new IndexedDataRow<double>("NMSE (test)", "Path of NMSE values over different lambda values", lambda.Zip(testNMSE, (l, v) => Tuple.Create(l, v))));
+      errorTable.Rows.Add(new IndexedDataRow<double>("Number of variables", "The number of non-zero coefficients for each step in the path", lambda.Zip(numNonZeroCoeffs, (l, v) => Tuple.Create(l, (double)v))));
       if (lambda.Length > 2) {
-        nmsePlot.VisualProperties.XAxisMinimumFixedValue = Math.Pow(10, Math.Floor(Math.Log10(lambda.Last())));
-        nmsePlot.VisualProperties.XAxisMaximumFixedValue = Math.Pow(10, Math.Ceiling(Math.Log10(lambda.Skip(1).First())));
-      }
-      nmsePlot.Rows["NMSE (train)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
-      nmsePlot.Rows["NMSE (test)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
-      nmsePlot.Rows["Number of variables"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
-      nmsePlot.Rows["Number of variables"].VisualProperties.SecondYAxis = true;
-
-
-      Results.Add(new Result(nmsePlot.Name, nmsePlot.Description, nmsePlot));
+        errorTable.VisualProperties.XAxisMinimumFixedValue = Math.Pow(10, Math.Floor(Math.Log10(lambda.Last())));
+        errorTable.VisualProperties.XAxisMaximumFixedValue = Math.Pow(10, Math.Ceiling(Math.Log10(lambda.Skip(1).First())));
+      }
+      errorTable.Rows["NMSE (train)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["NMSE (test)"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["Number of variables"].VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Points;
+      errorTable.Rows["Number of variables"].VisualProperties.SecondYAxis = true;
+                                                                                       
+      Results.Add(new Result(errorTable.Name, errorTable.Description, errorTable));
     }
 